/*
 * Copyright 2001-2005, Broadcom Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id$
 *
*/
 
#define wlconfig(name)	eval("wlconfig", name, "up")
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <syslog.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if_arp.h>
#include <bcmnvram.h>
#include <netconf.h>
#include <shutils.h>
#include <rc.h>
#include <wlutils.h>
//#include "./gemtek_added/Gemtek_Added_For_PPTP.h"	/* Added by PeterChen */

#define IFUP (IFF_UP | IFF_RUNNING | IFF_BROADCAST | IFF_MULTICAST)

// added by Jimmy Ma 2003.4.29
#define SIOCSETCIFENABLE	35323
#define SIOCSETCIPOK		35324

static int
LED_wan_ip_ok(int ok)
{
	int s, mydata;
	struct ifreq ifr;

	/* Open socket to kernel */
	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		return 0;

	strncpy(ifr.ifr_name, nvram_get("wanif"), IFNAMSIZ);
	mydata = ok;
	ifr.ifr_data = (void *)&mydata;

	if (ioctl(s, SIOCSETCIPOK, &ifr) < 0) 
	{
		close(s);
		return 0;
	}
	close(s);
	return 1;
}

#if 1
/* 3.51.21.0 */
void
start_lan(void)
{
	char *lan_ifname = nvram_safe_get("lan_ifname");
	char name[80], *next;
	int s;
	struct ifreq ifr;
	char	*wan_proto = nvram_safe_get ( "wan_proto" );
	pid_t	pid;
	
	dprintf("%s\n", lan_ifname);

 	/* Bring up bridged interfaces */
	if (strncmp(lan_ifname, "br", 2) == 0) {
		eval("brctl", "addbr", lan_ifname);
		eval("brctl", "setfd", lan_ifname, "0");
		if (nvram_match("router_disable", "1") || nvram_match("lan_stp", "0"))
			eval("brctl", "stp", lan_ifname, "dis");
		foreach(name, nvram_safe_get("lan_ifnames"), next) {
			/* Bring up interface */
			ifconfig(name, IFUP, NULL, NULL);
			/* Set the logical bridge address to that of the first interface */
			if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
				continue;
			strncpy(ifr.ifr_name, lan_ifname, IFNAMSIZ);
			if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0 &&
			    memcmp(ifr.ifr_hwaddr.sa_data, "\0\0\0\0\0\0", ETHER_ADDR_LEN) == 0) {
				strncpy(ifr.ifr_name, name, IFNAMSIZ);
				if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0) {
					strncpy(ifr.ifr_name, lan_ifname, IFNAMSIZ);
					ifr.ifr_hwaddr.sa_family = ARPHRD_ETHER;
					ioctl(s, SIOCSIFHWADDR, &ifr);
				}
			}
			close(s);
			/* If not a wl i/f then simply add it to the bridge */
			if (eval("wlconf", name, "up"))
			{
				//fprintf(stderr, "%s not a wl...\n", name);
				eval("brctl", "addif", lan_ifname, name);
			}
			else 
			{
				/* get the instance number of the wl i/f */
				char wl_name[] = "wlXXXXXXXXXX_mode";
				int unit;
				//fprintf(stderr, "%s is a wl...\n", name);
				wl_ioctl(name, WLC_GET_INSTANCE, &unit, sizeof(unit));
				snprintf(wl_name, sizeof(wl_name), "wl%d_mode", unit);

				//fprintf(stderr, "wl_name is %s\n", wl_name);
				//fprintf(stderr, "wet...match is %d\n", nvram_match(wl_name, "wet"));
				/* Receive all multicast frames in WET mode */
				if (nvram_match(wl_name, "wet"))
				{
					//fprintf(stderr, "wl_name(%s) is wet\n", wl_name);
					ifconfig(name, IFUP | IFF_ALLMULTI, NULL, NULL);
				}
				//fprintf(stderr, "wet...invmatch is %d\n", nvram_invmatch(wl_name, "wds"));
				/* Do not attach the main wl i/f if in wds mode */
				if (nvram_invmatch(wl_name, "wds"))
				{
					//fprintf(stderr, "wl_name(%s) is wds\n", wl_name);
					eval("brctl", "addif", lan_ifname, name);
				}
			}
		}
	}
	/* specific non-bridged lan i/f */
	else if (strcmp(lan_ifname, "")) {
		/* Bring up interface */
		ifconfig(lan_ifname, IFUP, NULL, NULL);
		/* config wireless i/f */
		if (!eval("wlconf", lan_ifname, "up")) {
			char tmp[100], prefix[] = "wanXXXXXXXXXX_";
			int unit;
			/* get the instance number of the wl i/f */
			wl_ioctl(lan_ifname, WLC_GET_INSTANCE, &unit, sizeof(unit));
			snprintf(prefix, sizeof(prefix), "wl%d_", unit);
			/* Receive all multicast frames in WET mode */
			if (nvram_match(strcat_r(prefix, "mode", tmp), "wet"))
				ifconfig(lan_ifname, IFUP | IFF_ALLMULTI, NULL, NULL);
		}
	}

	/* Get current LAN hardware address */
//	if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) >= 0) {
//		char eabuf[32];
//		strncpy(ifr.ifr_name, lan_ifname, IFNAMSIZ);
//		if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0)
//			nvram_set("lan_hwaddr", ether_etoa(ifr.ifr_hwaddr.sa_data, eabuf));
//		close(s);
//	}

	/* Bring up and configure LAN interface */
	//ifconfig(lan_ifname, IFUP, nvram_safe_get("lan_ipaddr"), nvram_safe_get("lan_netmask"));

	if (strcmp(wan_proto, "dhcp") == 0) {
		char *wan_hostname = nvram_get("wan_hostname");
		char *dhcp_argv[] = { "udhcpc",
				      "-i", lan_ifname,
				      "-p", "/var/run/udhcpc.pid",
				      "-s", "/tmp/udhcpc",
				      wan_hostname && *wan_hostname ? "-H" : NULL,
				      wan_hostname && *wan_hostname ? wan_hostname : NULL,
				      NULL
		};

		symlink("/sbin/rc", "/tmp/udhcpc");
		_eval ( dhcp_argv , NULL , 0 , &pid );
	} else {
		ifconfig(lan_ifname, IFUP, nvram_safe_get("wan_ipaddr"), nvram_safe_get("wan_netmask"));
		LED_wan_ip_ok(1);
	}	
}

void
stop_lan(void)
{
	char *lan_ifname = nvram_safe_get("lan_ifname");
	char name[80], *next;

	dprintf("%s\n", lan_ifname);

	/* Stop the syslogd daemon */
	eval("killall", "syslogd");

	/* Remove static routes */
//	del_lan_routes(lan_ifname);

	/* Bring down LAN interface */
	ifconfig(lan_ifname, 0, NULL, NULL);

	/* Bring down bridged interfaces */
	if (strncmp(lan_ifname, "br", 2) == 0) {
		foreach(name, nvram_safe_get("lan_ifnames"), next) {
			eval("wlconf", name, "down");
			ifconfig(name, 0, NULL, NULL);
			eval("brctl", "delif", lan_ifname, name);
		}
		eval("brctl", "delbr", lan_ifname);
	}
	/* Bring down specific interface */
	else if (strcmp(lan_ifname, ""))
		eval("wlconf", lan_ifname, "down");
	
	dprintf("done\n");
}
#endif

#if 0
/* Kings methos */
void	start_lan ( void )
{
	char	*lan_ifname = nvram_safe_get ( "lan_ifname" );
	char	*wan_proto = nvram_safe_get ( "wan_proto" );
	pid_t	pid;
	char	name [ 80 ] , *next = NULL;
	char	Buf [ 256 ];
	int	s = 0;
	struct ifreq	ifr;

	if ( ( s = socket ( AF_INET , SOCK_RAW , IPPROTO_RAW ) ) < 0 ) {
		return	NULL;
	}

	strncpy ( ifr.ifr_name , lan_ifname , IFNAMSIZ );

 	/* Bring up bridged interfaces */
	if ( strncmp ( lan_ifname , "br" ,  2 ) == 0 ) {
#if	1	/* Modified by PeterChen for speeding up */
		memset ( Buf , '\0' , 256 );
		sprintf ( Buf , "/usr/sbin/brctl addbr %s;/usr/sbin/brctl setfd %s 0;" , lan_ifname , lan_ifname );
		rc_system ( Buf );
#else
		eval ( "brctl" , "addbr" , lan_ifname );
		eval ( "brctl" , "setfd" , lan_ifname , "0" );
#endif
		foreach ( name , nvram_safe_get ( "lan_ifnames" ) , next ) {
			ifconfig ( name , IFUP , NULL , NULL );

			/* Only bridge main wireless interface in AP mode */
			if ( wlconfig ( name ) || nvram_match ( "wl_mode" , "ap" ) ) {
				eval ( "brctl" , "addif" , lan_ifname , name );
			}
		}
	}

	/* Bring up and configure LAN interface */
	//ifconfig ( lan_ifname, IFUP , nvram_safe_get ( "lan_ipaddr" ) , nvram_safe_get ( "lan_netmask" ) );
	
	if (strcmp(wan_proto, "dhcp") == 0) {
		char *wan_hostname = nvram_get("wan_hostname");
		char *dhcp_argv[] = { "udhcpc",
				      "-i", lan_ifname,
				      "-p", "/var/run/udhcpc.pid",
				      "-s", "/tmp/udhcpc",
				      wan_hostname && *wan_hostname ? "-H" : NULL,
				      wan_hostname && *wan_hostname ? wan_hostname : NULL,
				      NULL
		};

		symlink("/sbin/rc", "/tmp/udhcpc");
		_eval ( dhcp_argv , NULL , 0 , &pid );
	} else {
		ifconfig(lan_ifname, IFUP, nvram_safe_get("wan_ipaddr"), nvram_safe_get("wan_netmask"));
		LED_wan_ip_ok(1);
	}	

	close ( s );
}

void	stop_lan ( void )
{
	char *lan_ifname = nvram_safe_get("lan_ifname");
	char name[80], *next;
	dprintf("%s\n", lan_ifname);

	/* Stop the syslogd daemon */
	eval("killall", "syslogd");

	/* Bring down LAN interface */
	ifconfig(lan_ifname, 0, NULL, NULL);

	/* Bring down bridged interfaces */
	if (strncmp(lan_ifname, "br", 2) == 0) {
		foreach(name, nvram_safe_get("lan_ifnames"), next) {
			ifconfig(name, 0, NULL, NULL);
			eval("brctl", "delif", lan_ifname, name);
		}
		eval("brctl", "delbr", lan_ifname);
	}

	dprintf("done\n");
}
#endif

#if 0

#define	sin_addr(s)	(((struct sockaddr_in *)(s))->sin_addr)

void	start_wan ( void )
{
	char	*wan_ifname = nvram_safe_get ( "wan_ifname" );
	char	*wan_proto = nvram_safe_get ( "wan_proto" );
	char	*ifname = !strncmp ( wan_ifname , "ppp" , 3 ) ? nvram_safe_get("pppoe_ifname") : wan_ifname;
	int	s;
	pid_t	pid;
	struct ifreq	ifr;

	Gemtek_Added_For_PPTP_0001
/************ %%% ************** Added by PeterChen ************ %%% **************/
	char		*WAN_ENABLE = nvram_get ( "WAN_ENABLE" );

	if ( WAN_ENABLE != NULL ) {
		if ( strcmp ( WAN_ENABLE , "1" ) == 0 ) {	/* WAN is enabled */
			;	/* Doing nothing */
		} else {	/* WAN is disabled */
			goto		XXXXX;
		}
	} else {		/* if ( WAN_ENABLE == NULL ) */
XXXXX:	start_wan_done ();
		return	NULL;
	}	/* end of ( WAN_ENABLE != NULL ) */
/************ %%% ************** Added by PeterChen ************ %%% **************/

	if ( nvram_match ( "router_disable" , "1" ) || strcmp ( wan_proto , "disabled" ) == 0 ) {
		start_wan_done ();
		return	NULL;
	}

	if ( ( s = socket ( AF_INET , SOCK_RAW , IPPROTO_RAW ) ) < 0 ) {
		return	NULL;
	}

	/* Bring up enslaved WAN interface instead if PPPoE */
	strncpy ( ifr.ifr_name , ifname , IFNAMSIZ );

	/* Set WAN hardware address before bringing interface up */
	if (!nvram_invmatch("wan_hwaddr", "") ||
	    !e2_atoe(nvram_safe_get("wan_hwaddr"), ifr.ifr_hwaddr.sa_data) ||
	    !memcmp(ifr.ifr_hwaddr.sa_data, "\0\0\0\0\0\0", ETHER_ADDR_LEN)) {
		char perm[] = "XXXXXXmacaddr";
		
		if(!strcmp(nvram_safe_get("cpu_type"), "BCM4710") || !strcmp(nvram_safe_get("cpu_type"), "BCM4702"))
		{
			snprintf(perm, sizeof(perm) - 1, "%smacaddr", nvram_safe_get("wan_hwname"));
		}
		else if(!strcmp(nvram_safe_get("cpu_type"), "BCM3302") || !strcmp(nvram_safe_get("cpu_type"), "BCM4712"))
		{
			snprintf(perm, sizeof(perm) - 1, "%smacaddr", "et1");
		}

		e2_atoe(nvram_safe_get(perm), ifr.ifr_hwaddr.sa_data);
	}

	ifr.ifr_hwaddr.sa_family = ARPHRD_ETHER;
	ioctl ( s , SIOCSIFHWADDR , &ifr );

	/* Bring up underlying WAN interface */
	ifconfig ( ifname , IFUP , NULL , NULL );

	/* added by Jimmy Ma 2003.5.27 */
	LED_wan_ip_ok ( 0 );

	/* Configure WAN interface */
	if (strcmp(wan_proto, "pppoe") == 0) {
		char *pppoe_argv[] = { "pppoecd",
				       nvram_safe_get("pppoe_ifname"),
				       "-u", nvram_safe_get("pppoe_username"),
				       "-p", nvram_safe_get("pppoe_passwd"),
				       "-r", nvram_safe_get("pppoe_mru"),
				       "-t", nvram_safe_get("pppoe_mtu"),
				       "-i", nvram_match("pppoe_demand", "1") ? nvram_safe_get("pppoe_idletime") : "0",
				       nvram_match("pppoe_demand", "1") || nvram_match("pppoe_keepalive", "1") ? "-k" : NULL,
				       NULL
		};

		mkdir("/tmp/ppp", 0777);
		symlink("/sbin/rc", "/tmp/ppp/ip-up");
		symlink("/sbin/rc", "/tmp/ppp/ip-down");
		_eval(pppoe_argv, NULL, 0, &pid);

		/* Pretend that the WAN interface is up */
		if (nvram_match("pppoe_demand", "1")) {
			while (ifconfig(wan_ifname, IFUP,
//marked by Jimmy 2003.1.2					nvram_safe_get("wan_ipaddr"), "255.255.255.255"));
					NULL, "255.255.255.255"));
			/* Set P-t-P address if available */
			strncpy(ifr.ifr_name, wan_ifname, IFNAMSIZ);
			inet_aton(nvram_safe_get("wan_gateway"), &sin_addr(&ifr.ifr_dstaddr));
			ifr.ifr_dstaddr.sa_family = AF_INET;
			ioctl(s, SIOCSIFDSTADDR, &ifr);
			start_wan_done();
		}
	} else if (strcmp(wan_proto, "dhcp") == 0) {
		char *wan_hostname = nvram_get("wan_hostname");
		char *dhcp_argv[] = { "udhcpc",
				      "-i", wan_ifname,
				      "-p", "/var/run/udhcpc.pid",
				      "-s", "/tmp/udhcpc",
				      wan_hostname && *wan_hostname ? "-H" : NULL,
				      wan_hostname && *wan_hostname ? wan_hostname : NULL,
				      NULL
		};

		symlink("/sbin/rc", "/tmp/udhcpc");
		_eval ( dhcp_argv , NULL , 0 , &pid );
	} else {
		ifconfig(wan_ifname, IFUP,
			 nvram_safe_get("wan_ipaddr"), nvram_safe_get("wan_netmask"));
		LED_wan_ip_ok(1);
		start_wan_done();
		Gemtek_Added_For_PPTP_0004
		start_pptp_client ();	// added by PeterChen, Gemtek.	2003-1215 PM 04:47
	}

	/* Use enslaved WAN interface instead if PPPoE */
	strncpy ( ifr.ifr_name , ifname , IFNAMSIZ );

	/* Get current WAN hardware address */
	if ( ioctl ( s , SIOCGIFHWADDR , &ifr ) == 0 )
		nvram_set ( "wan_hwaddr" , e2_etoa ( ifr.ifr_hwaddr.sa_data ) );

	close ( s );

//	dprintf ( "%s %s\n" , nvram_safe_get ( "wan_ipaddr" ) , nvram_safe_get ( "wan_netmask" ) );
}

extern	char	wan_done_flag;
void	start_wan_done ( void )
{
	char	*wan_ifname = nvram_safe_get ( "wan_ifname" );

	/* Delete all default routes */
	while ( route_del ( wan_ifname , 0 , NULL , NULL , NULL ) == 0 ) { 
		;
	}

	/* Set default route to gateway if specified */
	route_add ( wan_ifname , 0 , "0.0.0.0" , nvram_safe_get ( "wan_gateway" ) , "0.0.0.0" );

	/* Start firewall */
//	start_firewall ();

	wan_done_flag = 1;

	/* Set additional static routes */
	set_routes ();

#if	0	/* Modified by PeterChen, Gemtek 2003-0702 PM 03:56 */
	/* Report stats */
	if ( nvram_invmatch ( "stats_server" , "" ) ) {
		char	*stats_argv[] = { "stats" , nvram_get ( "stats_server" ) , NULL };
		_eval ( stats_argv , NULL , 5 , NULL );
	}

	/* Sync time */
	if ( nvram_invmatch ( "ntp_server" , "" ) ) {
		char	*ntpclient_argv[] = { "ntpclient" , "-h" , nvram_get ( "ntp_server" ) , "-l" , "-s" , NULL };
		_eval ( ntpclient_argv , NULL , 5, NULL );
	}
#endif
}

void	stop_wan ( void )
{
	char *wan_ifname = nvram_safe_get("wan_ifname");
	dprintf("%s %s\n", wan_ifname, nvram_safe_get("wan_proto"));
	/* Stop firewall */
	stop_firewall();

	/* Kill any WAN client daemons or callbacks */
	eval("killall", "ip-up");
	eval("killall", "ip-down");
	eval("killall", "pppoecd");
	eval("killall", "udhcpc");
	eval("killall", "stats");
	eval("killall", "ntpclient");
/*	eval("killall", "nas");*/
	/* Bring down WAN interfaces */
	ifconfig(wan_ifname, 0, NULL, NULL);
	ifconfig(nvram_safe_get("pppoe_ifname"), 0, NULL, NULL);
	dprintf("done\n");
}

int
set_routes(void)
{
	char word[80], *tmp;
	char *ipaddr, *netmask, *gateway, *metric, *ifname;

	foreach(word, nvram_safe_get("static_route"), tmp) {
		netmask = word;
		ipaddr = strsep(&netmask, ":");
		if (!ipaddr || !netmask)
			continue;
		gateway = netmask;
		netmask = strsep(&gateway, ":");
		if (!netmask || !gateway)
			continue;
		metric = gateway;
		gateway = strsep(&metric, ":");
		if (!gateway || !metric)
			continue;
		ifname = metric;
		metric = strsep(&ifname, ":");
		if (!metric || !ifname)
			continue;
		route_add(ifname, atoi(metric) + 1, ipaddr, gateway, netmask);
	}
	return 0;
}
#endif

int
hotplug_net(void)
{
	char *interface, *action;

	if (!(interface = getenv("INTERFACE")) ||
	    !(action = getenv("ACTION")))
		return EINVAL;

	/* Bridge WDS interfaces */
	if (!strncmp(interface, "wds", 3)) {
		if (!strcmp(action, "register")) {
			ifconfig(interface, IFUP, NULL, NULL);
			return eval("brctl", "addif", nvram_safe_get("lan_ifname"), interface);
		} else if (!strcmp(action, "unregister"))
			return eval("brctl", "delif", nvram_safe_get("lan_ifname"), interface);
	}
	return 0;
}


/* Get current Wireless hardware address Added by YaoChung*/
void
GetWirelessMAC(void)
{
	int s;
	struct ifreq ifr;
	
	/* Only do this on 4702 */
	if(!strcmp(nvram_safe_get("cpu_type"), "BCM4710") || !strcmp(nvram_safe_get("cpu_type"), "BCM4702"))
	{
		if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
			return;
		strcpy(ifr.ifr_name, nvram_safe_get("wlif"));	
			if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0)
				nvram_set("wl_hwaddr", e2_etoa(ifr.ifr_hwaddr.sa_data));
		close(s);
		if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
			return;
		strcpy(ifr.ifr_name, "wlan");	
			if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0)
				nvram_set("wl_hwaddr_5G", e2_etoa(ifr.ifr_hwaddr.sa_data));
		close(s);	
	}
	
	nvram_set("wl0_hwaddr", nvram_safe_get("wl_hwaddr"));
}

#if 0
/* Get current Wireless hardware address Added by YaoChung*/
/* Get PPTP address, gateway and netmask Added by YaoChung*/
void
GetPPTPAddr(void)
{
	int s,s1;
	struct ifreq ifr,ifr1;
	char *wan_proto = nvram_get("wan_proto");
/*	printf("GetPPTPAddr............................................\n");*/
	if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
		return;
	if ((s1 = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
		return;		
	strcpy(ifr.ifr_name, "ppp0");
	strcpy(ifr1.ifr_name, "ppp1");
	nvram_set("pptp_ipaddr", "0.0.0.0");
	nvram_set("pptp_netmask", "0.0.0.0");
	nvram_set("pptp_dstaddr", "0.0.0.0");	
	if (!strcmp(wan_proto, "pppoe"))
	{
		if (ioctl(s, SIOCGIFADDR, &ifr1) == 0)
		{
/*			printf("PPP1 is ok............................................\n");*/
			nvram_set("pptp_ipaddr", inet_ntoa(sin_addr(&ifr1.ifr_addr)));
			if (ioctl(s, SIOCGIFNETMASK, &ifr1) == 0)
				nvram_set("pptp_netmask", inet_ntoa(sin_addr(&ifr1.ifr_netmask)));
			if (ioctl(s, SIOCGIFDSTADDR, &ifr1) == 0)					
				nvram_set("pptp_dstaddr", inet_ntoa(sin_addr(&ifr1.ifr_dstaddr)));
		}
	}
	else
	{
		if (ioctl(s, SIOCGIFADDR, &ifr) == 0)
		{
/*			printf("PPP0 is ok...............................................\n");*/
			nvram_set("pptp_ipaddr", inet_ntoa(sin_addr(&ifr.ifr_addr)));
			if (ioctl(s, SIOCGIFNETMASK, &ifr) == 0)
				nvram_set("pptp_netmask", inet_ntoa(sin_addr(&ifr.ifr_netmask)));
			if (ioctl(s, SIOCGIFDSTADDR, &ifr) == 0)					
				nvram_set("pptp_dstaddr", inet_ntoa(sin_addr(&ifr.ifr_dstaddr)));
		}
	}
	close(s);
	close(s1);
}

/* Get PPTP address, gateway and netmask Added by YaoChung*/
/* Start DDNS Added by YaoChung*/
void DDNSSet(void)
{
	pid_t pid;
	char cmdstr[150];
	char Useraccount[50];

	if (atoi(nvram_safe_get("DDNSEnable")) == 1 )	
	{
		sprintf(Useraccount, "%s:%s",nvram_safe_get("DDNSUsername"),nvram_safe_get("DDNSPassword"));
		sprintf(cmdstr, "/sbin/updatedd -S changeip -i eth1 -n %s -u %s &"	, nvram_safe_get("DDNSHostname"), Useraccount);
		WriteFile ( cmdstr );
	}
	else if (atoi(nvram_safe_get("DDNSEnable")) == 0 )	
	{
		sprintf(Useraccount, "%s:%s",nvram_safe_get("DDNSUsername"),nvram_safe_get("DDNSPassword"));
		sprintf(cmdstr, "/sbin/updatedd -s dyndns -n %s -u %s &"	, nvram_safe_get("DDNSHostname"), Useraccount);
		WriteFile ( cmdstr );
	}
	else if (atoi(nvram_safe_get("DDNSEnable")) == 2 )
	{
		//Disable, do nothing
	}			
}
/* Start DDNS Added by YaoChung*/
#endif
