/*
 * Copyright 2001-2005, Broadcom Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id$
 *
*/

#include <epivers.h>
#include <string.h>
#include <bcmnvram.h>
#include <typedefs.h>
#include <wlioctl.h>

#define XSTR(s) STR(s)
#define STR(s) #s



#define GEMTEK


#define GEMTEK_AP

#if defined(GEMTEK_AP)
#define MOTOROLA_SERIES
#define MOTOROLA_WE800G
#endif

struct nvram_tuple router_defaults[] = {
	/* Environment parameter */
	{ "boardtype" , "bcm94710dev" , 0 } ,
	{ "DefaultEthPort", "1", 0},
	{ "boardnum" , "2" , 0 } ,

	{ "clkfreq" , "125" , 0 } ,

	{ "et0phyaddr" , "30" , 0 } ,

	{ "et0mdcport" , "0" , 0 } ,

	{ "et1phyaddr" , "0" , 0 } ,

	{ "et1mdcport" , "1" , 0 } ,

	{ "dl_ram_addr" , "a0001000" , 0 } ,

	{ "os_ram_addr" , "80001000" , 0 } ,

	{ "os_flash_addr" , "bfc40000" , 0 } ,	
	{ "scratch" , "a0180000" , 0 } ,

	{ "boot_wait" , "off" , 0 } ,

	{ "watchdog" , "1000" , 0 } ,

	{ "sdram_init" , "0x0019" , 0 } ,

	{ "sdram_config" , "0x0000" , 0 } ,

	{ "sdram_refresh" , "0x8040" , 0 } ,	
		
	/* OS parameters */
	{ "lan_ifname", "", 0 },		/* LAN interface name */
	{ "lan_ifnames", "", 0 },		/* Enslaved LAN interfaces */
	{ "lan_hwnames", "", 0 },		/* LAN driver names (e.g. et0) */
	{ "wan_ifname", "", 0 },		/* WAN interface name */
	{ "wan_hwname", "", 0 },		/* WAN driver name (e.g. et1) */
#if defined(GEMTEK)

#else
	{ "wan_hwaddr", "", 0 },		/* WAN interface MAC address */
	{ "lan_hwaddr", "", 0 },		/* LAN interface MAC address */
#endif
	{ "os_name", "", 0 },			/* OS name string */
	{ "os_version", EPI_VERSION_STR, 0 },	/* OS revision */
	{ "os_date", __DATE__, 0 },		/* OS date */

	/* Miscellaneous parameters */
	{ "timer_interval", "3600", 0 },	/* Timer interval in seconds */
	{ "ntp_server", "192.5.41.40 192.5.41.41 133.100.9.2", 0 },		/* NTP server */
	{ "time_zone", "PST8PDT", 0 },		/* Time zone (GNU TZ format) */
	{ "log_level", "0", 0 },		/* Bitmask 0:off 1:denied 2:accepted */
	{ "upnp_enable", "0", 0 },		/* Start UPnP */
	{ "os_server", "", 0 },			/* URL for getting upgrades */
	{ "stats_server", "", 0 },		/* URL for posting stats */
	{ "console_loglevel", "1", 0 },		/* Kernel panics only */

	/* Big switches */
	{ "router_disable", "1", 0 },		/* lan_proto=static lan_stp=0 wan_proto=disabled */
	{ "fw_disable", "0", 0 },		/* Disable firewall (allow new connections from the WAN) */

	/* TCP/IP parameters */
	{ "log_ipaddr", "", 0 },		/* syslog recipient */
	{ "lan_proto", "dhcp", 0 },		/* [static|dhcp] */
	{ "lan_ipaddr", "192.168.1.1", 0 },	/* LAN IP address */
	{ "lan_netmask", "255.255.255.0", 0 },	/* LAN netmask */
	{ "lan_stp", "1", 0 },			/* LAN spanning tree protocol */
	{ "lan_wins", "", 0 },			/* x.x.x.x x.x.x.x ... */
	{ "lan_domain", "", 0 },		/* LAN domain name */
	{ "lan_lease", "86400", 0 },		/* LAN lease time in seconds */
#if defined(MOTOROLA_WE800G)
	{ "wan_proto", "static", 0 },		/* [static|dhcp|pppoe|disabled] */
	{ "wan_ipaddr", "192.168.30.1", 0 },	/* WAN IP address */
	{ "wan_netmask", "255.255.255.0", 0 },	/* WAN netmask */
#else
	{ "wan_proto", "dhcp", 0 },		/* [static|dhcp|pppoe|disabled] */
	{ "wan_ipaddr", "0.0.0.0", 0 },		/* WAN IP address */
	{ "wan_netmask", "0.0.0.0", 0 },	/* WAN netmask */
#endif
	{ "wan_gateway", "0.0.0.0", 0 },	/* WAN gateway */
	{ "wan_dns", "", 0 },			/* x.x.x.x x.x.x.x ... */
	{ "wan_wins", "", 0 },			/* x.x.x.x x.x.x.x ... */
	{ "wan_hostname", "", 0 },		/* WAN hostname */
	{ "wan_domain", "", 0 },		/* WAN domain name */

	{ "wan_lease", "86400", 0 },		/* WAN lease time in seconds */
	{ "static_route", "", 0 },		/* Static routes (ipaddr:netmask:gateway:metric:ifname ...) */

	/* Filters */
	{ "filter_maclist", "", 0 },		/* xx:xx:xx:xx:xx:xx ... */
	{ "filter_macmode", "deny", 0 },	/* "allow" only, "deny" only, or "disabled" (allow all) */
	{ "filter_client0", "", 0 },		/* [lan_ipaddr0-lan_ipaddr1|*]:lan_port0-lan_port1,proto,enable,day_start-day_end,sec_start-sec_end,desc */

	/* Port forwards */
	{ "dmz_ipaddr", "", 0 },		/* x.x.x.x (equivalent to 0-60999>dmz_ipaddr:0-60999) */
	{ "forward_port0", "", 0 },		/* wan_port0-wan_port1>lan_ipaddr:lan_port0-lan_port1[:,]proto[:,]enable[:,]desc */
	{ "autofw_port0", "", 0 },		/* out_proto:out_port,in_proto:in_port0-in_port1>to_port0-to_port1,enable,desc */

	/* DHCP server parameters */
	{ "dhcp_start", "192.168.1.100", 0 },	/* First assignable DHCP address */
	{ "dhcp_end", "192.168.1.150", 0 },	/* Last assignable DHCP address */
	{ "dhcp_domain", "wan", 0 },		/* Use WAN domain name first if available (wan|lan) */
	{ "dhcp_wins", "wan", 0 },		/* Use WAN WINS first if available (wan|lan) */

	/* Web server parameters */ 
#if defined(MOTOROLA_WE800G)  
	{ "http_username", "admin", 0 },	/* Username */
	{ "http_passwd", "motorola", 0 },	/* Password */
	{ "http_wanport", "80", 0 },		/* WAN port to listen on */
#else
	{ "http_username", "", 0 },		/* Username */
	{ "http_passwd", "admin", 0 },		/* Password */
	{ "http_wanport", "", 0 },		/* WAN port to listen on */
#endif
	{ "http_lanport", "80", 0 },		/* LAN port to listen on */

	/* PPPoE parameters */
	{ "pppoe_ifname", "", 0 },		/* PPPoE enslaved interface */
	{ "pppoe_username", "", 0 },		/* PPP username */
	{ "pppoe_passwd", "", 0 },		/* PPP password */
	{ "pppoe_idletime", "60", 0 },		/* Dial on demand max idle time (seconds) */
	{ "pppoe_keepalive", "0", 0 },		/* Restore link automatically */
	{ "pppoe_demand", "0", 0 },		/* Dial on demand */
	{ "pppoe_mru", "1500", 0 },		/* Negotiate MRU to this value */
	{ "pppoe_mtu", "1500", 0 },		/* Negotiate MTU to the smaller of this value or the peer MRU */
	{ "pppoe_service", "", 0 },		/* PPPoE service name */
	{ "pppoe_ac", "", 0 },			/* PPPoE access concentrator name */

	/* Wireless parameters */
	{ "wl_ifname", "", 0 },			/* Interface name */
	{ "wl_hwaddr", "", 0 },			/* MAC address */
	{ "wl_phytype", "b", 0 },		/* Current wireless band ("a" (5 GHz), "b" (2.4 GHz), or "g" (2.4 GHz)) */
	{ "wl_corerev", "", 0 },		/* Current core revision */
	{ "wl_phytypes", "", 0 },		/* List of supported wireless bands (e.g. "ga") */
	{ "wl_radioids", "", 0 },		/* List of radio IDs */
#if defined(MOTOROLA_WE800G)
	{ "wl_ssid", "", 0 },		/* Service set ID (network name) */
	{ "wl_country", "USA", 0 },		/* Country (default obtained from driver) */
#else
	{ "wl_ssid", "Broadcom", 0 },		/* Service set ID (network name) */
	{ "wl_country", "", 0 },		/* Country (default obtained from driver) */
#endif

	{ "wl_radio", "1", 0 },			/* Enable (1) or disable (0) radio */
	{ "wl_closed", "0", 0 },		/* Closed (hidden) network */
#if defined(MOTOROLA_WE800G)
	{ "wl_mode", "sta", 0 },		/* AP mode (ap|sta|wds) */
	{ "wl0_mode", "sta", 0 },		/* AP mode (ap|sta|wds) */	
#else
	{ "wl_mode", "ap", 0 },			/* AP mode (ap|sta|wds) */
#endif
	{ "wl_lazywds", "0", 0 },		/* Enable "lazy" WDS mode (0|1) */
	{ "wl_wds", "", 0 },			/* xx:xx:xx:xx:xx:xx ... */
	{ "wl_wep", "off", 0 },			/* Data encryption (off|wep|tkip|aes) */
	{ "wl_auth", "0", 0 },			/* Shared key authentication optional (0) or required (1) */
	{ "wl_key", "1", 0 },			/* Current WEP key */
	{ "wl_key1", "", 0 },			/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key2", "", 0 },			/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key3", "", 0 },			/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key4", "", 0 },			/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_maclist", "", 0 },		/* xx:xx:xx:xx:xx:xx ... */
	{ "wl_macmode", "disabled", 0 },	/* "allow" only, "deny" only, or "disabled" (allow all) */
	{ "wl_channel", "11", 0 },		/* Channel number */
	{ "wl_rate", "0", 0 },			/* Rate (bps, 0 for auto) */
	{ "wl_rateset", "default", 0 },		/* "default" or "all" or "12" */
	{ "wl_frag", "2346", 0 },		/* Fragmentation threshold */
	{ "wl_rts", "2347", 0 },		/* RTS threshold */
	{ "wl_dtim", "3", 0 },			/* DTIM period */
	{ "wl_bcn", "100", 0 },			/* Beacon interval */
	{ "wl_plcphdr", "long", 0 },		/* 802.11b PLCP preamble type */
	
	
	
	{ "wl_gmode", XSTR(GMODE_AUTO), 0 },	/* 54g mode */

	//{ "wl_gmode", XSTR(GMODE_LEGACY_B), 0 },	/* 54g mode */

	
	
	{ "wl_gmode_protection", "auto", 0 },	/* 802.11g RTS/CTS protection (off|auto) */
	{ "wl_frameburst", "off", 0 },		/* BRCM Frambursting mode (off|on) */

	/* WPA parameters */
	{ "wl_auth_mode", "disabled", 0 },	/* WPA mode (disabled|radius|wpa|psk) */
	{ "wl_wpa_psk", "", 0 },		/* WPA pre-shared key */
	{ "wl_wpa_gtk_rekey", "0", 0 },		/* WPA GTK rekey interval */
	{ "wl_radius_ipaddr", "", 0 },		/* RADIUS server IP address */
	{ "wl_radius_key", "", 0 },		/* RADIUS shared secret */
	{ "wl_radius_port", "1812", 0 },	/* RADIUS server UDP port */

	{ "wl_unit", "0", 0 },			/* Last configured interface */
		
	/* Restore defaults */
	{ "restore_defaults", "0", 0 },		/* Set to 0 to not restore defaults on boot */

#if defined(MOTOROLA_SERIES)
	/* For Motorola Series*/
	{ "ModelId", "WE800G" , 0 },
	{ "FirmwareVersion", "v1.00 July 9, 2003" , 0 }	,
	{ "login_msg", "", 0},                  /* login fail? */
	{ "EVENTLOGENABLE1", "1", 0},
	{ "EVENTLOGENABLE2", "1", 0},
	{ "EVENTLOGENABLE3", "1", 0},
	{ "logonidletimer", "10", 0},
	{ "NeedReboot", "0", 0},
	{ "move_to_defaults", "0", 0 },		/* Set to 0 to not restore defaults on boot */
	{ "wl_key_input_method", "0", 0},
	{ "wl_key_strength", "128", 0},
	{ "Enable802_1x", "0", 0},
 	{ "wl_passphrase", "motorola", 0 },

#endif
	//{ "WlEnable", "1" , 0 } ,		/* is this wl_radio? -- Joshua */
#if defined(MOTOROLA_WE800G)
	{ "wl_profile", "1", 0},
	{ "wl_network_type", "infra", 0 },	/* adhoc, infra */
	{ "wl_ssid_wp1", "", 0 },	/* Service set ID (network name) */
	{ "wl_ssid_wp2", "", 0 },	/* Service set ID (network name) */
	{ "wl_network_type_wp1", "infra", 0 },	/* adhoc, infra */
	{ "wl_network_type_wp2", "infra", 0 },	/* adhoc, infra */
	{ "wl_radio_wp1", "1", 0 },		/* Enable (1) or disable (0) radio */
	{ "wl_radio_wp2", "1", 0 },		/* Enable (1) or disable (0) radio */
	{ "wl_channel_wp1", "11", 0 },		/* Channel number */
	{ "wl_channel_wp2", "11", 0 },		/* Channel number */
	{ "wl_country_wp1", "USA", 0 },		/* Country (default obtained from driver) */
	{ "wl_country_wp2", "USA", 0 },		/* Country (default obtained from driver) */ 
	
	{ "wl_plcphdr_wp1", "long", 0 },	/* 802.11b PLCP preamble type */
	{ "wl_plcphdr_wp2", "long", 0 },	/* 802.11b PLCP preamble type */
	{ "wl_rts_wp1", "2347", 0 },		/* RTS threshold */
	{ "wl_rts_wp2", "2347", 0 },		/* RTS threshold */
	{ "wl_frag_wp1", "2346", 0 },		/* Fragmentation threshold */
	{ "wl_frag_wp2", "2346", 0 },		/* Fragmentation threshold */
	{ "wl_rateset_wp1", "all", 0 },	/* "default" or "all" or "12" */
	{ "wl_rateset_wp2", "all", 0 },	/* "default" or "all" or "12" */
	{ "wl_gmode_protection_wp1", "auto", 0 },	/* 802.11g RTS/CTS protection (off|auto) */
	{ "wl_gmode_protection_wp2", "auto", 0 },	/* 802.11g RTS/CTS protection (off|auto) */
	{ "wl_frameburst_wp1", "off", 0 },	/* BRCM Frambursting mode (off|on) */
	{ "wl_frameburst_wp2", "off", 0 },	/* BRCM Frambursting mode (off|on) */

	{ "wl_closed_wp1", "0", 0 },		/* Closed (hidden) network */
	{ "wl_closed_wp2", "0", 0 },		/* Closed (hidden) network */
	{ "wl_auth_mode_wp1", "disabled", 0 },	/* WPA mode (disabled|radius|wpa|psk) */
	{ "wl_auth_mode_wp2", "disabled", 0 },	/* WPA mode (disabled|radius|wpa|psk) */
	{ "wl_wep_wp1", "off", 0 },		/* Data encryption (off|wep|tkip|aes) */
	{ "wl_wep_wp2", "off", 0 },		/* Data encryption (off|wep|tkip|aes) */
	{ "wl_auth_wp1", "0", 0 },		/* Shared key authentication optional (0) or required (1) */
	{ "wl_auth_wp2", "0", 0 },		/* Shared key authentication optional (0) or required (1) */
	{ "wl_key_input_method_wp1", "0", 0},
	{ "wl_key_input_method_wp2", "0", 0},
	{ "wl_key_strength_wp1", "128", 0}, 
	{ "wl_key_strength_wp2", "128", 0},
	{ "wl_key_wp1", "1", 0 },		/* Current WEP key */
	{ "wl_key_wp2", "1", 0 },		/* Current WEP key */
	{ "wl_key1_wp1", "", 0 },		/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key2_wp1", "", 0 },		/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key3_wp1", "", 0 },		/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key4_wp1", "", 0 },		/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key1_wp2", "", 0 },		/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key2_wp2", "", 0 },		/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key3_wp2", "", 0 },		/* 5/13 char ASCII or 10/26 char hex */
	{ "wl_key4_wp2", "", 0 },		/* 5/13 char ASCII or 10/26 char hex */
	{ "Enable802_1x_wp1", "0", 0},
	{ "Enable802_1x_wp2", "0", 0},
	{ "wl_wpa_psk_wp1", "", 0}, /* WPA pre-shared key */
	{ "wl_wpa_psk_wp2", "", 0}, /* WPA pre-shared key */
	{ "wl_passphrase_wp1", "motorola", 0 },
	{ "wl_passphrase_wp2", "motorola", 0 },
	{ "wl_gmode_wp1", XSTR(GMODE_AUTO), 0},
	{ "wl_gmode_wp2", XSTR(GMODE_AUTO), 0},
#endif
	{ 0, 0, 0 }
};
